package edu.uiuc.cs.net.DPRPManager;
//package DPRPManager;

import java.io.*;
import java.util.*;
import java.net.*;

/**
 * This is a quick'n'dirty hack, to expiriment with running my existing
 * DPRP client code without a controller. It actually worked out pretty
 * well, and as such, that is how the XNap hack is implemented.
 */
public class ControllerlessClient {
    public static void main (String[] args) {

	DPRPClient.DEBUG = true;
	DPRPClient dpCli = new DPRPClient();
	String gatewayIP = "0.0.0.0"; /*prefs.getNatGwIp();*/
	int gatewayPort = 0; /*prefs.getNatGwPort();*/
	// probably unnecessary.
	if (gatewayPort == 0) {
	    gatewayPort = DPRPMessage.DEFAULT_PORT;
	}

	// Setup the DPRP client.
	InetAddress ti = null;
	try {
	    dpCli.setClientIP (InetAddress.getLocalHost());

	    if (gatewayIP.equals ("0.0.0.0")) {
		// guess the NAT GW's IP address
		System.out.println ("guessing srv addr");
		gatewayIP = dpCli.ourSrvAddrString();
	    }

	    ti = InetAddress.getByName (gatewayIP);
	    dpCli.setServerIP (ti);
	    dpCli.setServerPort (gatewayPort);
	    dpCli.setProtocol ("tcp");
	    dpCli.setFlags ((short)3);

	    if (DPRPClient.DEBUG)
		dpCli.dumpParameters();

	    dpCli.kickoffNewRequest();

	    // Sleep for 2 seconds
	    Thread.sleep (2000);

	    // Print-out what we've got.
	    if (dpCli.getExternalIP() != null)
		System.out.println ("External IP: " + dpCli.getExternalIP().getHostAddress());
	    else
		System.out.println ("External IP: null");
	    System.out.println ("External Port: " + dpCli.getExternalPort());
	    System.out.println ("Lease duration: " + dpCli.getDuration());

	    // wait and/or join
	    dpCli.waitForSession();
	} catch (UnknownHostException e) {
	    System.err.println (e);
	    System.exit (66);
	} catch (InterruptedException e) {
	    System.err.println (e);
	    System.exit (69);
	}
    } /* End main(). */
}
