package edu.uiuc.cs.net.DPRPManager;
//package DPRPManager;

/**
 * This interface defines a number of constants that are useful for the
 * client(s) to do their business. This needs refactoring, because I
 * have constants scattered all over this code base.
 *
 * @version 1.0 - October 16th, 2001
 * @author Andy Reitz (<a href="mailto:areitz@cs.uiuc.edu">areitz@cs.uiuc.edu</a>)
 */
public interface DPRPClientConstants {
    /**
     * Constant -- the number of times to re-send a message, without
     * receiving a reply from the server.
     */
    static final int NUM_RETRIES = 10;

    /** Demarcating the beginning of the "<i>halt group</i>". */
    static final int HALT                      = 100;
    /** Lease loop halted because first lease acquire attempt failed. */
    static final int HALT_ACQUIRE_LEASE        = 101;
    /** Lease loop halted because the server NACK'd our lease. */
    static final int HALT_SERVER_NACK          = 102;
    /** Lease loop halted because the t2 timer expired. */
    static final int HALT_T2_EXPIRED           = 103;
    /** Lease loop halted because response was received from the server. */
    static final int HALT_NO_RESPONSE          = 104;
    /** Lease loop tried to sleep for an invalid time (likely negative). */
    static final int HALT_INVALID_SLEEP_TIMER  = 105;
    /** Lease loop was interrupted by contoller. Event must be processed. */
    static final int HALT_INTERRUPTED          = 106;

    /** Demarcating the beginning of the "<i>client command</i>" group. */
    static final int CLI_COMMAND               = 200;
    /** Contoller is forcing an immediate lease update. */
    static final int CLI_FORCE_LEASE_UPDATE    = 201;
    /** Client is forcing an immediate lease termination. */
    static final int CLI_FORCE_LEASE_TERMINATE = 202;
    /** Client is forcing the entire thread to exit. */
    static final int CLI_TERMINATE_THREAD      = 203;

    /*
     * GUI constants.
     */
    /** The string presented to the user for the client IP field. */
    static final String cliIPFieldString = "Local IP Address";
    /** The string presented to the user for the gateway IP address field. */
    static final String srvIPFieldString = "Gateway IP Address";
    /** The label string for the listening port on the gateway. */
    static final String srvPortFieldString = "Gateway Port";
    /** The label string for the desired lease protocol. */
    static final String reqProtocolFieldString = "Requested protocol";
    /** the label string fo the requested external port. */
    static final String reqPortFieldString = "Requested external port";
    /** The label string for the desired lease duration. */
    static final String reqDurationFieldString = "Requested lease " +
	"duration";
    /** The string on the reset button. */
    static final String resetButtonString = "Reset to defaults";
    /** The string on the OK button. */
    static final String okButtonString = "Get lease!";
    /** The string on the update lease button. */
    static final String updateButtonString = "Update lease";
    /** The string on the squash lease button. */
    static final String terminateButtonString = "Terminate lease";

    /*
     * Command-constants (for CLI, right as of now).
     */
//     static final char CLI_NEW_LEASE      = 'n';
//     static final char CLI_UPDATE_LEASE   = 'u';
//     static final char CLI_TERMINATE_NORM = 'm';
//     static final char CLI_ERROR          = 'e';
} /* End interface DPRPClientConstants. */
