package edu.uiuc.cs.net.DPRPManager;

/**
 * This interface comprises the methods that must be supported by something
 * that wishes to act as a "DPRP Lease Listener". Namely, something that
 * wishes to receive events that contain DPRP leases. These events will be
 * sourced by the <b><tt>DPRPClient</tt></b> object, and contain updated
 * leases that correspond with server activity.
 *
 * @version 1.0 - September 28th, 2001
 * @author Andy Reitz (<a href="mailto:areitz@cs.uiuc.edu">areitz@cs.uiuc.edu</a>)
 */
public interface DPRPLeaseListener extends DPRPLeaseListenerConstants {
    /** Method definition for that which receives a fired lease event. */
    public void receiveLease (DPRPLeaseEvent ple);
} /* End interface DPRPLeaseListener. */
