// bug-du-jour -- after forced lease update, i can no-longer fuck with
// that lease, to rm it or update it. FUCK!!!!

package edu.uiuc.cs.net.DPRPManager;
//package DPRPManager;

import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;

// Gayer-than-Gay. For ListSelectionListener
import javax.swing.event.*;

// Gayer-than-Mike-Hunter-Gay.
import java.util.jar.*;

/**
 * A GUI version of the ubiquituous DPRP client.
 *
 * I'm going to need to keep some sort of list of DPRPClient object instances,
 * so that when I have the JTable setup, and users' mess with individual
 * leases, we can get back with the client that has that lease outstanding,
 * and make the change. Actually, it's going to need to be a list of
 * DPRPClients, and their ThreadID's (so that they can be interrupted while
 * they are sleeping).
 * <p>
 * Explore <b><tt>JOptionPane</tt></b>, for simple dialogs (errors and such).
 * <p>
 * For the JTable button thing, I'm going to have to setup a mouse listener,
 * that pokes a bunch of variables with the current data that is highlighted.
 * Also, it will make the button.setEnabled(true) whenever something is
 * highlighted. At start, this will be false, and if we can ever de-select
 * entirely, then it must be false (dunno if I have to worry about that).
 *
 * @version 1.1 - October 30th, 2001
 * @author Andy Reitz (<a href="mailto:areitz@cs.uiuc.edu">areitz@cs.uiuc.edu</a>)
 */
public class GUI_DPRPClient implements ActionListener,
				       DPRPLeaseListener,
				       DPRPClientConstants {
    /** The name of the main GUI window. */
    private String frameTitle = "Graphical DPRP Client v1.1";
    /** The main frame for the entire application. */
    private JFrame frame;
    /** A reference to the current protocol selected in the list box. */
    private String curProtocolSelected = null;

    /**
     * A map of leases that this client has outstanding. The keys
     * are actual <b><tt>DPRPLease</tt></b> object references, and the
     * associated values are to the <b><tt>DPRPClient</tt></b> objects
     * that manage said lease. This mapping is needed so that the
     * appropriate <b><tt>DPRPClient</tt></b> can be interrupted when
     * the user wants to update and/or terminate a specific lease.
     *
     * <b><tt>HashMap</tt></b> isn't thread-safe. I really should pick
     * something else, ya?
     */
    private HashMap lease2ClientMap;

    /**
     * My localized model for the JTable of outstanding DPRP leases.
     * I need to have a class-global reference to this model, so that
     * it can be added as a listener to newly-instantiated clients.
     */
    private DPRPLeaseTableModel tableModel;

    /**
     * The table itself is now a global reference, so that the buttons
     * can be grey'd out upon lease termination.
     */
    private final JTable table;
    /** Update lease button; Global for table-grey-out purposes. */
    private final JButton updateButton;
    /** Terminate lease button; Global for table-grey-out purposes. */
    private final JButton terminateButton;
    /**
     * A reference to the <b><tt>DPRPLease</tt></b> object that is in
     * the current, user-selected row in the table. For some reason,
     * this seems ugly, yet, I don't know of any better way.
     */
    private DPRPLease curSelectedLease = null;

    /** The text field that holds the client IP address. */
    private JTextField cliIPField;
    /** The text field that holds the DPRP-enabled gateway's IP address. */
    private JTextField srvIPField;
    /**
     * The text field that holds the port on the DPRP-enabled gateway. I
     * should probably do something fancy, like change the document model,
     * so that only numbers can be inputted. But, I'm doing error checking
     * so, who cares?!?!?
     */
    private JTextField srvPortField;
    /** The list box, where the protocol is selected. */
    private JComboBox reqProtocolList;
    /** The text field for the requested port. 0 means take next available. */
    private JTextField reqPortField;
    /** The text field for the requested lease duration, in seconds. */
    private JTextField reqDurationField;

    /** The default path for help files. */
    private static final String HELP_PATH = "DPRPManager" +
	System.getProperty ("file.separator") +
	"helpFiles" +
	System.getProperty ("file.separator");

    /**
     * Constructor.
     */
    public GUI_DPRPClient() {
	lease2ClientMap = new HashMap();

	// All of these things must be global & initialized here, just so
	// that I can grey-out the buttons when they should be so. Gay.
	tableModel = new DPRPLeaseTableModel();
	table = new JTable (tableModel);
	updateButton = new JButton (updateButtonString);
	terminateButton = new JButton (terminateButtonString);
    } /* End constructor. */

    /**
     * The main() method: the action starts here.
     */
    public static void main (String args[])
    {
	GUI_DPRPClient mainWindow = new GUI_DPRPClient();

	try {
	    System.out.println ("Stay tuned to this window for "
				+ "important messages from our sponsor...\n");
	    mainWindow.launchGUI();
	} catch (Exception ex) {
		System.out.println ("GUI_DPRPClient fatal error: " + ex);
	}
    } /* End main(). */

    /**
     * Handles all drawing on the main frame, and display of said frame.
     * This method invokes sub-methods, in order to get each half of
     * the display setup, it slaps those <b><tt>JPanels</tt></b> on, and
     * then sets the whole thing to be visible.
     */
    private void launchGUI()
    {
	frame = new JFrame (frameTitle);

	frame.addWindowListener (new WindowAdapter() {
		public void windowClosing (WindowEvent e) {
		    System.exit(0);
		}
	    });

	// Establish the menu bar across the top.
	createMenuBar();

	// Establish the main window layout.
	createMainWindowLayout();

	// Last thing
	frame.pack();
	frame.setVisible (true);
    } /* End launchGUI(). */

    /**
     * Creates the main window layout, which consists of a top and
     * bottom half. The top half is where new leases are requested,
     * and the bottom half is where currently-held leases are managed.
     */
    private void createMainWindowLayout() {
	// Create the pane that sets up new leases. This will comprise
	// the top-half of the window.
	JPanel newLeasePane = createNewLeasePanel();
        newLeasePane.setBorder(
                BorderFactory.createCompoundBorder(
                      BorderFactory.createTitledBorder("Acquire a new lease:"),
                      BorderFactory.createEmptyBorder(5,5,5,5)));

	// Create the pane that manages current leases. This will comprise
	// the bottom-half of the window.
	JPanel manageLeasesPane = createManageLeasesPanel();
        manageLeasesPane.setBorder(
             BorderFactory.createCompoundBorder(
                BorderFactory.createTitledBorder("Manage outstanding leases:"),
                BorderFactory.createEmptyBorder(5,5,5,5)));

	// Finally, setup the main window.
	JPanel contentPane = new JPanel();
	BoxLayout contentBox = new BoxLayout (contentPane, BoxLayout.Y_AXIS);
	contentPane.setLayout (contentBox);
	contentPane.add (newLeasePane);
	contentPane.add (manageLeasesPane);
	frame.setContentPane (contentPane);
    } /* End createMainWindowLayout(). */

    /**
     * Creates the panel that accepts user-input and control of requesting
     * new leases. Essentially, it just creates all of the labels and
     * text input fields, and slaps them down in a pseudo 3x4 table
     * arrangement.
     */
    private JPanel createNewLeasePanel() {
	// Create some panels.
	JPanel retPanel = new JPanel();
	JPanel inputPanel = new JPanel();
	JPanel buttonPanel = new JPanel();
	JLabel tmpL;

	// Create the client IP text-input field.
	cliIPField = new JTextField (10);
	cliIPField.setToolTipText ("This should be the IP address of the " +
				   "interface on the local machine that " +
				   "you wish to use.");
	tmpL = new JLabel (cliIPFieldString + ": ");
	tmpL.setForeground (Color.black);
	tmpL.setLabelFor (cliIPField);
	JLabel cliIPLabel = tmpL;

	// Create the server IP text-input field.
	srvIPField = new JTextField (10);
	srvIPField.setToolTipText ("The IP address or hostname of the " +
				   "DPRP-enabled gateway to request a lease " +
				   "from.");
	tmpL = new JLabel (srvIPFieldString + ": ");
	tmpL.setForeground (Color.black);
	tmpL.setHorizontalTextPosition (JLabel.RIGHT);
	tmpL.setLabelFor (srvIPField);
 	JLabel srvIPLabel = tmpL;

	// Create the server Port text-input field.
	srvPortField = new JTextField (10);
	srvPortField.setToolTipText ("The port on the DPRP-enabled gateway " +
				     "to connect to, initially.");
	tmpL = new JLabel (srvPortFieldString + ": ");
	tmpL.setForeground (Color.black);
	tmpL.setHorizontalTextPosition (JLabel.RIGHT);
	tmpL.setLabelFor (srvPortField);
 	JLabel srvPortLabel = tmpL;

	// Create the requested protocol text-input field.
	// this should really be a drop-down list
	tmpL = new JLabel (reqProtocolFieldString + ": ");
	tmpL.setForeground (Color.black);
	tmpL.setHorizontalTextPosition (JLabel.RIGHT);

	// Build the list box-o-protocols.
	reqProtocolList = new JComboBox (DPRPMessage.supportedProtocols);
	reqProtocolList.setToolTipText ("Choose which protocol your " +
					"application wishes to use.");
	reqProtocolList.setSelectedIndex (0);
	reqProtocolList.addActionListener (new ActionListener() {
		public void actionPerformed (ActionEvent e) {
		    JComboBox cb = (JComboBox)e.getSource();
		    curProtocolSelected = (String)cb.getSelectedItem();
		}
	    });

 	JLabel reqProtocolLabel = tmpL;

	// Create the requested port text-input field.
	reqPortField = new JTextField (10);
	reqPortField.setToolTipText ("The port number that you want to " +
				     "reserve for your application. Set as " +
				     "0 to request any free port.");
	tmpL = new JLabel (reqPortFieldString + ": ");
	tmpL.setForeground (Color.black);
	tmpL.setHorizontalTextPosition (JLabel.RIGHT);
	tmpL.setLabelFor (reqPortField);
 	JLabel reqPortLabel = tmpL;

	// Create the server IP text-input field.
	reqDurationField = new JTextField (10);
	reqDurationField.setToolTipText ("The desired lease duration, " +
					 "in seconds.");
	tmpL = new JLabel (reqDurationFieldString + ": ");
	tmpL.setForeground (Color.black);
	tmpL.setHorizontalTextPosition (JLabel.RIGHT);
	tmpL.setLabelFor (reqDurationField);
 	JLabel reqDurationLabel = tmpL;

	// Setup the initial values.
	resetTextFieldsToDefaults();

	// Arrange all of the input elements and labels into a 3x4 array,
	// for placement on the canvas (using a GridBagLayout vessel).
	JComponent[][] inpGroup = new JComponent[3][4];
	// row 1
	inpGroup[0][0] = cliIPLabel;
	inpGroup[0][1] = cliIPField;
	inpGroup[0][2] = reqProtocolLabel;
	inpGroup[0][3] = reqProtocolList;

	// row 2
	inpGroup[1][0] = srvIPLabel;
	inpGroup[1][1] = srvIPField;
	inpGroup[1][2] = reqPortLabel;
	inpGroup[1][3] = reqPortField;

	// row 3
	inpGroup[2][0] = srvPortLabel;
	inpGroup[2][1] = srvPortField;
	inpGroup[2][2] = reqDurationLabel;
	inpGroup[2][3] = reqDurationField;

	GridBagLayout gridbag = new GridBagLayout();
	inputPanel.setLayout (gridbag);
	makeLabelTextLayout (inpGroup, gridbag, inputPanel);

	// Make 'dem buttons.
	JButton resetButton = new JButton (resetButtonString);
	resetButton.setToolTipText ("Reset all of the above fields to " +
				    "their default values.");
	resetButton.setMnemonic (resetButtonString.charAt (0));
	resetButton.addActionListener (this);
	JButton okButton = new JButton (okButtonString);
	okButton.setToolTipText ("Try and acquire a lease using the " +
				 "above values.");
	okButton.setMnemonic (okButtonString.charAt (0));
	okButton.addActionListener (this);
	//frame.setDefaultButton (okButton);

	// Layout the buttons.
        buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
        buttonPanel.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
        buttonPanel.add(Box.createHorizontalGlue());
        buttonPanel.add(resetButton);
        buttonPanel.add(Box.createRigidArea(new Dimension(10, 0)));
        buttonPanel.add(okButton);

	retPanel.setLayout (new BoxLayout (retPanel, BoxLayout.Y_AXIS));
	retPanel.add (inputPanel);
	retPanel.add (Box.createRigidArea(new Dimension(0, 10)));
	retPanel.add (buttonPanel);

	// Adios.
	return (retPanel);
    } /* End createNewLeasePanel(). */

    /**
     * Paints the JTabel that displays currently outstanding leases.
     */
    private JPanel createManageLeasesPanel() {
	// Make the button panel.
	updateButton.setToolTipText ("Force an update on the selected lease.");

	updateButton.setMnemonic (updateButtonString.charAt (0));
	updateButton.addActionListener (this);
	terminateButton.setToolTipText ("Terminate the selected lease " +
					"immediately, removing the " +
					"translation on the gateway.");
	terminateButton.setMnemonic (terminateButtonString.charAt (0));
	terminateButton.addActionListener (this);

	// Make then not enabled to start with.
	updateButton.setEnabled (false);
	terminateButton.setEnabled (false);

	// Layout the buttons.
	JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
        buttonPanel.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
        buttonPanel.add(Box.createHorizontalGlue());
        buttonPanel.add(updateButton);
        buttonPanel.add(Box.createRigidArea(new Dimension(10, 0)));
        buttonPanel.add(terminateButton);

	// Now, do the table jiggy.
	table.setPreferredScrollableViewportSize (new Dimension  (500, 70));

	// Create scrollpane and add the table to it. Duh.
	JScrollPane scrollPane = new JScrollPane (table);

	// Handle the row-selection stuff. From the java/Swing
	// trail -- what is ListSelectionModel? It's an interface, I know
	// that much.
	table.setSelectionMode (ListSelectionModel.SINGLE_SELECTION);
	ListSelectionModel rowSM = table.getSelectionModel();
	rowSM.addListSelectionListener (new ListSelectionListener() {
		public void valueChanged (ListSelectionEvent e) {
		    // Ignore extra messages. ???
		    if (e.getValueIsAdjusting())
			return;

		    ListSelectionModel lsm = (ListSelectionModel)e.getSource();

		    if (DPRPClient.DEBUG)
			System.out.println ("cMLP-vC: Fired:\n" +
					    "\tlsm.isSelectionEmpty() = " +
					    lsm.isSelectionEmpty() + "\n" +
					    "\trowCount = " +
					    table.getRowCount() + "\n" +
					    "\tclientMap empty = " +
					    lease2ClientMap.isEmpty());

		    // There is some sort of defect here, in that the
		    // isSelectionEmpty() method doesn't work when the
		    // table has data, and then it is all deleted. So,
		    // like a fool, I'm just blindly checking the number of
		    // rows in the table. It seems to work aaight.
		    if (lsm.isSelectionEmpty() || (table.getRowCount() == 0) ||
			(lease2ClientMap.isEmpty())) {
			// no rows selected, turn off the buttons.
			if (DPRPClient.DEBUG)
			    System.out.println ("cMLP-vC: Turning off " +
						"buttons.");
			curSelectedLease = null;
			updateButton.setEnabled (false);
			terminateButton.setEnabled (false);
		    } else {
			int selectedRow = lsm.getMinSelectionIndex();
			if (DPRPClient.DEBUG)
			    System.out.println ("cMLP-vC: Turning on " +
						"buttons for row " +
						selectedRow + ".");
			// Little error-check.
			if (selectedRow == -1)
			    return;

			// okay, we know which row is selected.
			// extract the data, and setup the button.
		        curSelectedLease = tableModel.getLeaseAt (selectedRow);
			updateButton.setEnabled (true);
			terminateButton.setEnabled (true);
		    }
		} /* End valueChanged(). */
	    });

	JPanel retPanel = new JPanel();
	retPanel.setLayout (new BoxLayout (retPanel, BoxLayout.Y_AXIS));
	retPanel.add (scrollPane);
	retPanel.add (Box.createRigidArea(new Dimension(0, 10)));
	retPanel.add (buttonPanel);

	return (retPanel);
    } /* End createManageLeasesPanel(). */

    /**
     * Attempts to get a new <b><tt>DPRPLease</tt></b>, based upon the
     * current form information. This method goes ahead and extracts the
     * form data, and error checks it. If this data is found to be
     * kosher, it is stuffed into the <b><tt>DPRPClient</tt></b>
     * instance, and the lease fetching process is launched.
     */
    public void acquireNewLease() {
	// Some day, this will have to include some reference, so that
	// the client can source new events at us (putting them in our
	// EventHandler thread).
	DPRPClient client = new DPRPClient();
	InetAddress tmp = null;
	Integer iObj = null;
	try {
	    tmp = InetAddress.getByName (cliIPField.getText());
	    client.setClientIP (tmp);
	    tmp = InetAddress.getByName (srvIPField.getText());
	    client.setServerIP (tmp);
	    iObj = new Integer (srvPortField.getText());
	    client.setServerPort (iObj.intValue());

	    // The protocol is handled by the combo box action listener.
	    if (curProtocolSelected != null)
		client.setProtocol (curProtocolSelected);

	    iObj = new Integer (reqPortField.getText());
	    client.setRequestedPort (iObj.intValue());
	    iObj = new Integer (reqDurationField.getText());
	    client.setDuration (iObj.intValue());

	    // This is comin' from the GUI.
	    client.setFlags ((short)2);

	    // Now, we're ready to set the client a'rockin'.
	    if (DPRPClient.DEBUG)
		client.dumpParameters();
	    
	    // Oh hell...
	    client.addDPRPLeaseListener (this);
	    client.addDPRPLeaseListener (tableModel);
	    client.kickoffNewRequest();
	} catch (UnknownHostException e) {
	    System.out.println ("** aNL: Got a bad hostname: " + e);
	    return;
	} catch (NumberFormatException e) {
	    System.out.println ("** aNL: Got a bad integer: " + e);
	    return;
	}
    } /* End acquireNewLease(). */

    /**
     * This will be called whenever the "get lease" button is smacked, or
     * the "reset to defaults" button.
     */
    public void actionPerformed (ActionEvent e) {
	if (e.getActionCommand().equals (resetButtonString)) {
	    // reset action
	    if (DPRPClient.DEBUG)
		System.out.println ("GUI: Got reset button press.");
	    resetTextFieldsToDefaults();
	} else if (e.getActionCommand().equals (okButtonString)) {
	    // ok command, launch new lease gettin' process.
	    if (DPRPClient.DEBUG)
		System.out.println ("GUI: Got OK button press.");
	    acquireNewLease();
	} else if (e.getActionCommand().equals (updateButtonString)) {
	    // Got an update button press.
	    if (DPRPClient.DEBUG) {
		System.out.println ("GUI: Update received for this lease:");
		curSelectedLease.prettyPrint();
	    }
	    // Should I suck in any values from the text-o box-o?

	    // Determine which DPRPClient is in command of this lease,
	    // and poke it.
	    DPRPClient cc = (DPRPClient)lease2ClientMap.get (curSelectedLease);
	    if (cc == null) {
		// A most ugly error.
		System.err.println ("GUI: Target lease of update action " +
				    "not found. Dying...");
		System.exit (33);
	    }
	    if (DPRPClient.DEBUG)
		System.out.println ("GUI: got client object instance: " + cc +
				    "; which is of class: " +
				    cc.getClass().getName());
	    cc.sentRequest = CLI_FORCE_LEASE_UPDATE;
	    cc.interruptSession();
	} else if (e.getActionCommand().equals (terminateButtonString)) {
	    if (DPRPClient.DEBUG) {
		System.out.println ("GUI: Terminate received for this lease:");
		curSelectedLease.prettyPrint();
	    }

	    DPRPClient cc = (DPRPClient)lease2ClientMap.get (curSelectedLease);
	    if (cc != null) {
		if (DPRPClient.DEBUG)
		    System.out.println ("GUI: got client object instance: " +
					cc + "; which is of class: " +
					cc.getClass().getName());
		cc.sentRequest = CLI_FORCE_LEASE_TERMINATE;
		cc.interruptSession();
	    }
	} else {
	    System.err.println ("** GUI: Unknown action received: " + e);
	}
    } /* End actionPerformed(). */

    /**
     * This gets called whenever a <b><tt>DPRPClient</tt></b> object
     * instance decides that it has a lease that we need to see.
     *
     * Handling an update request is going to be tricky -- we're going
     * to have to use our list of DPRPClients, and match the getSource()
     * on the event to the appropriate client instance.
     */
    public void receiveLease (DPRPLeaseEvent ple) {
	if (DPRPClient.DEBUG) {
	    System.out.println ("Got DPRPLeaseEvent from: " + ple.getSource());
	    System.out.println ("Command: " +
		  DPRPLeaseEvent.resolveLeaseCommand (ple.getCommand()));
	    if (ple.getLease() != null) {
		System.out.println ("Received lease contents:");
		ple.getLease().prettyPrint();
	    }
	    System.out.println ("Number of leases in map: " +
				lease2ClientMap.size());
	}

	String msg = null;
	if (ple.getCommand() == NEW_LEASE_EVENT) {
	    // The client sent us a new lease event. Check to see if it
	    // represents an error, or if we got a bonafide lease.
	    if (ple.isError()) {
		// Notify the client of this situation.
		msg = "Error occured obtaining lease:\n" +
		    DPRPErrors.resolveError (ple.getErrorcode());
		JOptionPane.showMessageDialog (frame, msg,
					       "Acquire Lease Error",
					       JOptionPane.ERROR_MESSAGE);
		return;
	    }

	    // We got a valid lease, let 'em know!
	    DPRPLease evLease = ple.getLease();
	    DPRPClient evClient = (DPRPClient)ple.getSource();
	    lease2ClientMap.put (evLease, evClient);

	    // Only throw up this dialog if this is a genuinely new lease.
	    if (ple.isNew()) {
		msg = "New lease acquired:" + "\nExternal IP Address: " +
		    evLease.getExternalIP().getHostAddress() +
		    "\nExternal Port: " + evLease.getExternalPort() +
		    "\nProtocol: " + evLease.getProtocolStr();
		JOptionPane.showMessageDialog (frame, msg);
	    }
	} else if (ple.getCommand() == REMOVE_LEASE_EVENT) {
	    // Find the source in the map, and snuff it. Not too sure
	    // about user-notification at this point. Should probably
	    // display the NACK reason, assuming I get that working...
	    DPRPClient evClient = (DPRPClient)ple.getSource();
	    DPRPLease evLease = ple.getLease();

	    // Returns a DPRPClient...
	    lease2ClientMap.remove (evLease);

	    // Check to see if this is this was the last lease in the table,
	    // and if so, we'll try and grey-out those buttons. Note, that
	    // I actually had to make the buttons class-global, because
	    // Java is eminently-gay, and just clearning the selection
	    // doesn't fire a "valueChanged()" event.
	    //
	    // Actually, to prevent really wierd behavior, I'm going to
	    // gray-out after every delete, not just for the table-empty
	    // condition.
	    if (DPRPClient.DEBUG)
		System.out.println ("Deleting lease, attempting " +
				    "to gray-out buttons.");

	    // This doesn't work, but it's here to remind me of that
	    // fact.
	    ListSelectionModel rowSM = table.getSelectionModel();
	    rowSM.clearSelection();

	    // Witness the heavy-hand of justice.
	    curSelectedLease = null;
	    updateButton.setEnabled (false);
	    terminateButton.setEnabled (false);

	    // another failed experiment. This is actually harmful, so
	    // it's commented out.
// 	    ListSelectionModel rowSM = table.getSelectionModel();
// 	    rowSM.setSelectionInterval (0, 0);

	    // Display a notification message to the user.
	    msg = "Lease expired:" + "\nExternal IP Address: " +
		evLease.getExternalIP().getHostAddress() +
		"\nExternal Port: " + evLease.getExternalPort() +
		"\nProtocol: " + evLease.getProtocolStr();
	    if (!ple.isError()) {
		// Not an error, so just do the normal thing.
		JOptionPane.showMessageDialog (frame, msg);
	    } else {
		// Display a special error message.
		msg += "\nAdditionally, the following error was received:\n";
		if (ple.getErrorcode() == DPRPErrors.CLI_SERVER_NACK_ERROR)
		    msg += DPRPErrors.resolveError (evLease.getNackError());
		else
		    msg += DPRPErrors.resolveError (ple.getErrorcode());

		JOptionPane.showMessageDialog (frame, msg,
					       "Terminate Lease Error",
					       JOptionPane.ERROR_MESSAGE);
	    }
	} else if (ple.getCommand() == UPDATE_LEASE_EVENT) {
	    // Update this lease in the 'lease2ClientMap' map.
	    DPRPClient tmpCli = (DPRPClient)lease2ClientMap.remove (ple.getLease());
	    lease2ClientMap.put (ple.getLease(), tmpCli);

	    // The JTable is going to somehow have to map lease entries
	    // to DPRPClient instances. Thus, we can go ahead and silently
	    // update the table. This will happen by firing an event
	    // at DPRPLeaseTableModel, most likely.
	    if (ple.isError()) {
		msg = "Error occured updating lease:\n" +
		    DPRPErrors.resolveError (ple.getErrorcode());
		JOptionPane.showMessageDialog (frame, msg,
					       "Update Lease Error",
					       JOptionPane.ERROR_MESSAGE);
		return;
	    }

	    // Not error, so, we'll just be silent. Want leases to update
	    // without user having to click "ok". 'kay?
	} else {
	    System.err.println ("** GUI-ERROR: Invalid lease event command " +
				"received! Command: " + ple.getCommand());
	    // Should probably halt the entire client...
	}

    } /* End receiveLease(). */

    /************************************************************************/
    /* Utility methods.                                                     */
    /************************************************************************/
    /**
     * Drops the labels and text fields into the grid bag layout.
     */
    private void makeLabelTextLayout (JComponent[][] parts,
				      GridBagLayout gridbag,
				      Container container) {
	GridBagConstraints labelC = new GridBagConstraints();
	GridBagConstraints textBoxC = new GridBagConstraints();

        //c.anchor = GridBagConstraints.EAST;

	// Setup the constraints for labels.
	labelC.weightx = 0.0;
	// Huh. This doesn't really jive with the description,
	// but it has a positive effect on things.
	labelC.fill = GridBagConstraints.NONE;
	labelC.anchor = GridBagConstraints.EAST;

	// Setup the constraints for text input boxes.
	textBoxC.fill = GridBagConstraints.HORIZONTAL;
	textBoxC.anchor = GridBagConstraints.WEST;
	textBoxC.weightx = 0.5;
	// Add 10 pixels to the right of each text box.
	textBoxC.insets = new Insets (0, 0, 0, 10);

	int numRows = parts.length;
	int numCols = parts[0].length;
	int rc;  // row counter.
	int cc;  // column counter.
	boolean dropLabel = true;  // we're dropping down a label.
	for (rc = 0; rc < numRows; rc++) {
	    for (cc = 0; cc < numCols; cc++) {
		if (dropLabel) {
		    labelC.gridy = rc;
		    labelC.gridx = cc;
		    gridbag.setConstraints (parts[rc][cc], labelC);
		    container.add (parts[rc][cc]);
		    dropLabel = false;
		} else {
		    textBoxC.gridy = rc;
		    textBoxC.gridx = cc;
		    gridbag.setConstraints (parts[rc][cc], textBoxC);
		    container.add (parts[rc][cc]);
		    dropLabel = true;
		}
	    } /* for columns */
	} /* for rows */
    } /* End makeLabelTextLayout(). */

    /**
     * Reset all of the text input fields for establishing a new lease to
     * their default values.
     */
    private void resetTextFieldsToDefaults() {
	// This is a gross, gross hack.
	DPRPClient client = new DPRPClient();
	cliIPField.setText (client.ourAddrString());
	srvIPField.setText (client.ourSrvAddrString());
	srvPortField.setText (client.ourSrvPortString());
	reqProtocolList.setSelectedIndex (0);
	reqPortField.setText ("0");
	reqDurationField.setText ("500");
    } /* resetTextFieldsToDefaults(). */

    /**
     * Create (and populate) the menubar.
     */
    public void createMenuBar ()
    {
	JMenuBar menuBar = new JMenuBar();
	JMenuItem item;

	// File menu.
	JMenu fileMenu = new JMenu ("File");
	fileMenu.setToolTipText ("Save current leases, or load past " +
				 "leases from disk.");
	fileMenu.setMnemonic ('F');
	menuBar.add (fileMenu);

	// Open...
	fileMenu.add (item = new JMenuItem ("Open lease file..."));
	item.setMnemonic ('O');
	item.addActionListener (new ActionListener() {
		/**
		 * This action throws up one of those spiffy-standard-Swing
		 * Open dialogs, and sends the resulting filename to
		 * <b><tt>loadData()</tt></b>.
		 */
		public void actionPerformed (ActionEvent e) {
		    // if lease2ClientMap is non-empty, throw out a 
		    // warning dialog.
		    if (!lease2ClientMap.isEmpty()) {
			Object[] buttonTexts = {"Proceed", "Cancel"};
			int choice = JOptionPane.showOptionDialog (frame,
			      "Beware! Bringing in a saved set of leases " +
			      "will terminate those that you currently have.",
			      "Confirm load leases",
			      JOptionPane.YES_NO_OPTION,
			      JOptionPane.WARNING_MESSAGE,
			      null,        // Dunno what this is.
			      buttonTexts,
			      buttonTexts[1]);
			if (choice != 0)
			    return;
		    }
		    JFileChooser fc = new JFileChooser();
		    int retval = fc.showOpenDialog (frame);
	
		    if (retval == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			loadLeases (file);
		    }
		} /* End actionPerformed(). */
	    });

	// Save...
	fileMenu.add (item = new JMenuItem ("Save leases to file..."));
	item.setMnemonic ('S');
	item.addActionListener (new ActionListener() {
		/**
		 * This action throws up one of those spiffy-standard-Swing
		 * Save dialogs, and sends the resulting filename to
		 * <b><tt>saveData()</tt></b>.
		 */
		public void actionPerformed (ActionEvent e) {
		    JFileChooser fc = new JFileChooser();
		    int retval = fc.showSaveDialog (frame);
		
		    if (retval == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			saveLeases (file);
		    }
		} /* End actionPerformed(). */
	    });

	// Quit
	fileMenu.addSeparator();
	fileMenu.add (item = new JMenuItem ("Quit"));
	item.setMnemonic ('Q');
	item.addActionListener (new ActionListener() {
		public void actionPerformed (ActionEvent e) {
		    System.exit(0);
		}
	    });

	// Debug menu
	JMenu debugMenu = new JMenu ("Debug");
	debugMenu.setToolTipText ("Special menu for enabling certain " +
				  "features that are useful for debugging.");
	debugMenu.setMnemonic ('D');
	menuBar.add (debugMenu);

	final JCheckBoxMenuItem cbItem;
	cbItem = new JCheckBoxMenuItem ("Display debug messages");
	cbItem.setMnemonic ('i');
	cbItem.addItemListener (new ItemListener() {
		public void itemStateChanged (ItemEvent e) {
		    Object source = e.getItemSelectable();
		    if ((source == cbItem) &&
			(e.getStateChange() == ItemEvent.SELECTED)) {
			DPRPClient.DEBUG = true;
			DPRPLease.DEBUG = true;
		    } else if ((source == cbItem) &&
			       (e.getStateChange() == ItemEvent.DESELECTED)) {
			DPRPClient.DEBUG = false;
			DPRPLease.DEBUG = false;
		    }

		    if (DPRPClient.DEBUG)
			System.out.println ("GUI: Debugging messages on.");
		} /* End itemStateChanged(). */
	    });
	debugMenu.add (cbItem);

	// Push the help off to the right.
	menuBar.add(Box.createHorizontalGlue());

	// Help menu.
	JMenu helpMenu = new JMenu ("Help");
	helpMenu.setToolTipText ("Receive assistance in using this program.");
	helpMenu.setMnemonic ('H');
	menuBar.add (helpMenu);
	//menuBar.setHelpMenu (helpMenu);

	// Help->Creating a new lease.
	helpMenu.add (item = new JMenuItem ("Creating a new lease..."));
	item.setMnemonic ('C');
	item.addActionListener (new HelpAction (HELP_PATH +
						"helpCreatingLease.html",
						"Help creating a new lease",
						this));

	// Help->Managing leases.
	helpMenu.add (item = new JMenuItem ("Managing leases..."));
	item.setMnemonic ('M');
	item.addActionListener (new HelpAction (HELP_PATH +
						"helpManagingLeases.html",
						"Help managing leases",
						this));

// 	// Help->About.
	// add a separator here (well, before here).
// 	helpMenu.add (item = new JMenuItem ("About..."));
// 	item.setMnemonic ('A');
// 	item.addActionListener (new HelpAboutAction (frame, this));

	// Make it visible, and we're out!
	frame.setJMenuBar (menuBar);
    } /* End createMenuBar(). */

    /**
     * Writes out the currently held leases to disk. The file name that we
     * write to is chosen by the user, via one of those spiffy Swing-standard
     * file chooser dialogs. This method checks to make sure the leases
     * are valid while writing them out, and refuses to write an expired
     * lease. Said lease will then be removed from the client-side of things.
     * @param outFile The output file for the leases.
     */
    public void saveLeases (File outFile) {
	HashSet initLeaseSet = new HashSet (lease2ClientMap.keySet());
	HashSet modLeaseSet = new HashSet (lease2ClientMap.keySet());
	modLeaseSet = DPRPLease.writeLeaseFile (outFile, modLeaseSet);

	// Check to see if we got an un-recoverable error.
	if (modLeaseSet == null)
	    return;

	if (initLeaseSet.size() != modLeaseSet.size()) {
	    Iterator it = initLeaseSet.iterator();
	    while (it.hasNext()) {
		DPRPLease cur = (DPRPLease)it.next();
		if (!modLeaseSet.contains (cur)) {
		    if (DPRPClient.DEBUG) {
			System.out.println ("GUI: Bonzer! Found an expired " +
					    "lease on *save* of all things. " +
					    "Purging from system:");
			cur.prettyPrint();
		    }

		    // This lease isn't in the return set, it must have
		    // expired (somehow).
		    DPRPClient pc = (DPRPClient)lease2ClientMap.get (cur);
		    pc.sentRequest = CLI_TERMINATE_THREAD;
		    pc.interruptSession();
		    lease2ClientMap.remove (cur);
		    // update the table? Maybe the DPRPClient will kick out
		    // an update event? Yeah, I think that it will. This
		    // is probably all untestable, tho...
		}
	    } /* while */
	} /* if */
    } /* End saveLeases(). */

    /**
     * Loads in a set of leases from disk, replacing any currently held
     * leases with the from-disk set. Note, this means that if we have
     * currently outstanding leases, they will be TERMINATED. This means
     * that they will be removed not only from the client, but from
     * the server as well. This is because if they are removed from
     * the client, then there is no active way to manage them, and thus
     * these leases should no longer exist. Thus, this functionality must
     * be used with caution. <code>:)</code>
     * @param inpFile The file name, from which we cull the leases.
     */
    public void loadLeases (File inpFile) {
	HashSet readLeaseSet = null;
	try {
	    // Suck in a whole mess of leases.
	    readLeaseSet = DPRPLease.readLeaseFile (inpFile);

	    if (readLeaseSet.size() == 0)
		// Screw this.
		throw new IOException ("No valid leases were found");

	    // If we get here, scratch out the current lease2Client map.
	    HashSet clients = new HashSet (lease2ClientMap.values());
	    Iterator clit = clients.iterator();
	    while (clit.hasNext()) {
		DPRPClient cpc = (DPRPClient)clit.next();
		// This is going to cause LEASE_DELETE events to be sent
		// back to us. NOTE: I want this to actually snuff leases,
		// because if they are kicked out of the GUI, then there
		// is no way to manage them further.
		cpc.sentRequest = CLI_FORCE_LEASE_TERMINATE;
		cpc.interruptSession();
	    }

	    // Force everything to be garbage-collected.
	    lease2ClientMap = new HashMap();

	    // Okay, now kick off a new client session for each lease found.
	    Iterator it = readLeaseSet.iterator();
	    while (it.hasNext()) {
		DPRPLease cur = (DPRPLease)it.next();
		// This sort of thing should probably be methodized...
		DPRPClient newCli = new DPRPClient (cur);
		newCli.addDPRPLeaseListener (this);
		newCli.addDPRPLeaseListener (tableModel);
		newCli.kickoffNewRequest();
		lease2ClientMap.put (cur, newCli);
	    }
	} catch (IOException e) {
	    // Throw up an error dialog saying that there was a problem.
	    JOptionPane.showMessageDialog (frame, "Error occured while " +
					   "attempting to read lease file " +
					   "from disk:\n " + e,
					   "Load Leases Error",
					   JOptionPane.ERROR_MESSAGE);
	}
	
    } /* End loadLeases(). */

    /**
     * Throws up a help dialog, showing the given filename inside.
     */
    public void createNewHelpDialog (String labelText, String fname) {
        // Create an editor pane.
        JEditorPane helpPane = createHelpPane (fname);
	if (helpPane == null) {
	    System.err.println ("** cNHD: Got null from cHP(). Erroring out.");
	    return;
	}

        JScrollPane helpScrollPane = new JScrollPane(helpPane);
        helpScrollPane.setVerticalScrollBarPolicy (
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        helpScrollPane.setPreferredSize(new Dimension(250, 145));
        helpScrollPane.setMinimumSize(new Dimension(10, 10));

	// Create the dialog, and slap the html in it.
	JDialog dialog = new JDialog (frame, labelText, false);
	JPanel dialogPanel = new JPanel();
	dialog.setContentPane (dialogPanel);
	dialogPanel.add (helpScrollPane);

	// Cleanup.
	dialog.pack();
	dialog.setLocationRelativeTo (frame);

	// Is this a blocking call, for modal dialog boxes?
	dialog.setVisible (true);
    } /* End createNewHelpDialog(). */

    /**
     * Loads an HTML document into a <b><tt>JEditorPane</tt></b> instance,
     * and returns said instance. Returns null if any error. Mostly stolen
     * from '<tt>TextSamplerDemo.java</tt>', available on from the Swing
     * tutorial on java.sun.com.
     * @param fname The name of the help file to be opened, relative to
     *  the cwd.
     * @return A <b><tt>JEditorPane</tt></b> containing the HTML, or NULL
     *  if the file wasn't found.
     */
    private JEditorPane createHelpPane (String fname) {
        JEditorPane helpPane = null;
	String s = null;
	URL helpURL = null;

	helpPane = new JEditorPane();
	helpPane.setEditable (false);
	s = System.getProperty ("user.dir")
	    + System.getProperty ("file.separator");

        try {
            helpURL = new URL ("file:" + s + fname);

	    // Check to see if this first attempt actually worked. If the
	    // setPage() tosses an IOException, then we won't return this
	    // particular 'pane.
	    helpPane.setPage (helpURL);
	    if (DPRPClient.DEBUG)
		System.out.println ("cHP: Setting help URL to: " + helpURL);
	    return (helpPane);
        } catch (MalformedURLException e) {
	    if (DPRPClient.DEBUG)
		System.err.println ("** cHP: Couldn't create help URL: " + s);
        } catch (IOException e) {
	    if (DPRPClient.DEBUG) {
		System.err.println ("** cHP: " + e);
// 		e.printStackTrace();
	    }
        }

	// Okay, so either the help file doesn't exist, or we are running
	// from a JAR file. Let's try the JAR approach:
	try {
	    if (DPRPClient.DEBUG)
		System.out.println ("cHP: Attempting to open jar file: " + s +
				    "GUI_DPRPClient.jar");

	    JarFile jf = new JarFile (s + "GUI_DPRPClient.jar");
	    if (DPRPClient.DEBUG) {
		Enumeration enum = jf.entries();
		while (enum.hasMoreElements())
		    System.err.println ("cHP: jar element: " + enum.nextElement());
	    }

	    // it'd be easier if i just created fname properly.
	    if (System.getProperty ("file.separator").equals ("\\")) {
		// We're on windoze. Fuck Sun up their stupid asses.
		// Well, that was a lot easier than I thought it'd be.
		fname = fname.replace ('\\', '/');
	    }

	    if (DPRPClient.DEBUG)
		System.err.println ("cHP: looking for file in jar: " + fname);
	    java.util.zip.ZipEntry jE = jf.getEntry (fname);
	    if (DPRPClient.DEBUG)
		System.err.println ("cHP: found jarEntry: " + jE);
	    if (jE == null) {
		if (DPRPClient.DEBUG)
		    System.out.println ("cHP: couldn't find file '" + fname +
					"' in jar file: " + jf);
		return (helpPane);
	    }

	    InputStream helpStream = jf.getInputStream (jE);
	    // This is so gay.
	    helpPane.setEditorKit (helpPane.getEditorKitForContentType ("text/html"));
	    helpPane.read (helpStream, new javax.swing.text.html.HTMLDocument());
	} catch (IOException e) {
	    System.err.println ("** cHP-JAR: " + e);
// 	    e.printStackTrace();
	}


        return helpPane;
    } /* End createHelpPane(). */

} /* End class GUI_DPRPClient. */

/************************************************************************/
/* Action classes, for the menu.                                        */
/************************************************************************/
/**
 * This class is instantiated at menu-object-creation time, and
 * invoked upon user input. For each invocation, a dialog box is
 * thrown up, displaying the appropriate help file.
 */
class HelpAction implements ActionListener {
    /** The name of the help file to display. */
    private String fname;
    /** The title to be displayed in the dialog. */
    private String windowTitle;
    /** A reference to the gui client, to invoke the dialog creation method. */
    private GUI_DPRPClient curClient;

    /**
     * Constructor for this action.
     * @param f A string, representing the name of an HTML help file.
     * @param t A string, representing the title of the new dialog.
     * @param gpc A reference to the current client, for dialog creation.
     */
    public HelpAction (String f, String t, GUI_DPRPClient gpc) {
	fname = f;
	windowTitle = t;
	curClient = gpc;
    }

    /**
     * Invoked whenever this action is triggered by the user (usually
     * via a mouse click). This will cause a new dialog box to be
     * thrown up, displaying the help text relevent to this action.
     * @param e An <b><tt>ActionEvent</tt></b> instance, that contains
     *  something, I guess...
     */
    public void actionPerformed (ActionEvent e) {
	/*
	 * If I register a "window listener" with this dialog, then I
	 * can prevent the same help dialog from being opened twice. If
	 * the boolean is false, then a new dialog will be created, and
	 * the boolean will be set to true. On dialog close, the 
	 * window listener will kick in, and reset the flag to false.
	 * When a new action is invoked, the flag will be checked, and
	 * if it is true, we won't make any new dialog.
	 */
	curClient.createNewHelpDialog (windowTitle, fname);
    } /* End actionPerformed(). */
} /* End class HelpCreateAction. */

// class HelpAboutAction implements ActionListener {
// }
